window.listDirectory = (url, options, cb) ->
	if typeof options is 'function'
		cb = options
		options = {}

	fail = (err) ->
		# cb(err)

	resolveSuccess = (entry) ->
		readEntriesSuccess = (entries) ->
			window.entries = entries
			names = []
			for entry in entries
				names.push entry.name
				console.log entry.name
			# cb null, names

		reader = entry.createReader()
		reader.readEntries readEntriesSuccess, fail

	window.resolveLocalFileSystemURL url, resolveSuccess, fail


window.writeFile = (directoryPath, fileName, content, cb) ->
	fail = (err) ->
		cb err, null

	resolveSuccess = (dirEntry) ->
		getFileSuccess = (fileEntry) ->
			createWriterSuccess = (writer) ->
				writer.onwrite = (evt, a) ->
					cb null, evt.target.result

				writer.onerror = fail
				writer.write content

			fileEntry.createWriter createWriterSuccess, fail

		getFileOptions =
			create: true
			exclusive: false

		dirEntry.getFile fileName, getFileOptions, getFileSuccess, fail

	window.resolveLocalFileSystemURL directoryPath, resolveSuccess, fail


window.readFile = (directoryPath, fileName, cb) ->
	fail = (err) ->
		cb err, null

	resolveSuccess = (dirEntry) ->
		getFileSuccess = (fileEntry) ->
			fileSuccess = (file) ->
				reader = new FileReader()

				reader.onloadend = (e) ->
					cb null, this.result

				reader.readAsText file

			fileEntry.file fileSuccess, fail

		dirEntry.getFile fileName, {}, getFileSuccess, fail

	window.resolveLocalFileSystemURL directoryPath, resolveSuccess, fail

window.removeFile = (directoryPath, fileName, cb) ->
	resolveSuccess = (dirEntry) ->
		getFileSuccess = (fileEntry) ->
			fileEntry.remove cb

		dirEntry.getFile fileName, {}, getFileSuccess

	window.resolveLocalFileSystemURL directoryPath, resolveSuccess

window.writeDir = (directoryPath, dirName, cb) ->
	fail = (err) ->
		cb err, null

	resolveSuccess = (dirEntry) ->
		getDirectorySuccess = (fileEntry) ->
			console.log('created')

		dirEntry.getDirectory dirName, {create: true}, getDirectorySuccess, fail

	window.resolveLocalFileSystemURL directoryPath, resolveSuccess, fail


window.removeDir = (directoryPath, cb) ->
	fail = (err) ->
		cb err, null

	resolveSuccess = (dirEntry) ->
		removeRecursivelySuccess = ->
			console.log('Directory removed')

		dirEntry.removeRecursively removeRecursivelySuccess, fail

	window.resolveLocalFileSystemURL directoryPath, resolveSuccess, fail


window.ensurePath = (path, cb) ->
	fail = (err) ->
		console.log err
		cb()

	createDir = (parent, folders) ->
		getDirectorySuccess = (dirEntry) ->
			folders.shift()
			if folders.length > 0
				createDir dirEntry, folders
			else
				cb()

		parent.getDirectory folders[0], {create: true}, getDirectorySuccess, fail

	window.resolveLocalFileSystemURL cordova.file.dataDirectory, (dirEntry) ->
		createDir dirEntry, path.split('/')
	, fail


window.copyFile = (src, dest, cb) ->
	dest = dest.split '/'

	destName = dest.pop()
	destPath = dest.join '/'

	fail = (desc) ->
		return (err) ->
			console.log err, desc, src, destPath, destName
			cb()

	resolveSrcSuccess = (srcEntry) ->
		resolveDestSuccess = (destDirEntry) ->

			copyFile = ->
				copyToSuccess = ->
					console.log 'copied', destPath, destName
					cb()
				srcEntry.copyTo destDirEntry, destName, copyToSuccess, fail('copy')

			getFileSuccess = (fileEntry) ->
				fileEntry.remove()
				copyFile()

			getFileFail = ->
				copyFile()

			destDirEntry.getFile destName, {}, getFileSuccess, getFileFail

		ensurePath destPath, ->
			window.resolveLocalFileSystemURL cordova.file.dataDirectory + destPath, resolveDestSuccess, fail('dest')

	window.resolveLocalFileSystemURL src, resolveSrcSuccess, fail('src')



# document.addEventListener "deviceready", ->
# 	window.openOrginal = window.open

# 	window.open = (strUrl, strWindowName, strWindowFeatures)->
# 		if !options
# 			options = 'location=no,enableViewportScale=yes,zoom=yes';

# 		callbacks = {
# 			loaderror: (e)->
# 				console.error e.message
# 				return
# 			,
# 			message: (e) ->
# 				console.log e.message
# 				return
# 		}
# 		popup = cordova.InAppBrowser.open(strUrl, strWindowName, options);
# 		for (var callbackName in callbacks) {
# 			popup.addEventListener(callbackName, callbacks[callbackName]);
# 		}
# 		# 这个函数好像没必要，但是会导致 meteor oauth 弹出窗口奔溃
# 		popup.show = ()->
# 			return
# 		return popup

# 5 秒内按两次后退按钮退出
document.backButtonLastClicked = false
document.addEventListener 'backbutton', ->
	if document.backButtonLastClicked 
		if new Date() - document.backButtonLastClicked < 5000
			document.backButtonLastClicked = false
			navigator.Backbutton.goHome()
	document.backButtonLastClicked = new Date()
	return

window.handleOpenURL = (url)->
	console.log("received url: " + url)
	window.setTimeout(()->
		handle_openURL = (u)->
			if window.Steedos && window.Steedos.handleOpenURL && window.Session && window.Session.get('spaceId')
				window.Steedos.handleOpenURL(u)
			else
				window.setTimeout(()->
					handle_openURL(u)
				,1000)
		handle_openURL(url)
	,0)

# When notification clicked to open the app
document.addEventListener 'huaweipush.notificationOpened', ((event)->
	extras = event.extras
	notificationOpened = (exts)->
		if window.Steedos && window.Steedos.notificationOpened && window.Session && window.Session.get('spaceId')
			window.Steedos.notificationOpened(exts)
		else
			window.setTimeout(()->
				notificationOpened(exts)
			,1000)
	notificationOpened(extras)

).bind(this), false



document.addEventListener "deviceready", ->
	img = document.getElementById("logo")
	if img
		img.src = window.cordovai18n('Logo') + "?r" + Math.random()
	return



