// Generated by CoffeeScript 1.12.7
(function() {
  var addAlert, serverAddressInput, updateServer;

  window.AUTOLOAD = true;

  window.updateQuickActions = function() {
    return ThreeDeeTouch.isAvailable(function(avail) {
      var actions, i, len, ref, server;
      if (avail !== true) {
        return;
      }
      ThreeDeeTouch.enableLinkPreview();
      actions = [];
      ref = Servers.getServers();
      for (i = 0, len = ref.length; i < len; i++) {
        server = ref[i];
        actions.push({
          type: server.url,
          title: server.name,
          iconType: 'Home'
        });
      }
      return ThreeDeeTouch.configureQuickActions(actions);
    });
  };

  window.registerServer = function(serverAddress) {
    var name;
    if (serverAddress == null) {
      serverAddress = $('#serverAddress').val().trim().toLowerCase();
    }
    if (serverAddress.length === 0) {
      serverAddress = $("#serverAddress").attr("placeholder");
    }
    $('#serverAddress').val(serverAddress);
    name = serverAddress.replace(/https?:\/\//, '').replace(/^www\./, '');
    $(document.body).addClass('loading');
    $('.loading-text').text(cordovai18n("Validating_server"));
    return setTimeout(function() {
      return Servers.registerServer(name, serverAddress, function(err) {
        if (err != null) {
          console.error(cordovai18n("Failed_to_register_the_server_s_s", serverAddress, err));
          return setTimeout(function() {
            $('#serverAddress').addClass('error');
            addAlert({
              type: 'danger',
              message: err
            });
            return $(document.body).removeClass('loading');
          }, 1500);
        }
        refreshServerList();
        $('.loading-text').text(cordovai18n("Downloading_files"));
        return Servers.downloadServer(serverAddress, function(status) {
          if (status.err != null) {
            Servers.deleteServer(serverAddress);
            $(document.body).removeClass('loading');
            alert(cordovai18n("Error_downloading_files_please_try_again_later"));
            return;
          }
          if (status.done === true) {
            $('.loading-text').text(cordovai18n("Loading_s", name));
            return Servers.save(function() {
              return Servers.startServer(serverAddress, function() {});
            });
          } else {
            return $('.loading-text').html(cordovai18n("Downloading_files_s_s", status.count, status.total));
          }
        });
      });
    }, 250);
  };

  updateServer = function(url, version) {
    var name, server;
    server = Servers.getServer(url);
    if (server == null) {
      return;
    }
    if (server.info.version === version) {
      return;
    }
    $(document.body).addClass('loading');
    $('.loading-text').text(cordovai18n("Updating_files"));
    name = server.name;
    return Servers.updateServer(url, function(status) {
      if (status.err != null) {
        alert(cordovai18n("Error_downloading_files_please_try_again_later"));
        $('.loading-text').text(cordovai18n("Loading_s", server.name));
        Servers.startServer(url, function() {});
        return;
      }
      if (status.done === true) {
        $('.loading-text').text(cordovai18n("Loading_s", server.name));
        Servers.save();
        return Servers.startServer(url, function() {});
      } else {
        return $('.loading-text').html(cordovai18n("Updating_files_s_s", status.count, status.total));
      }
    });
  };

  serverAddressInput = function() {
    if ($('#serverAddress').hasClass('error')) {
      return setTimeout(function() {
        $('#serverAddress').removeClass('error');
        return $('#alert-messages').empty();
      }, 1000);
    }
  };

  addAlert = function(alertObj) {
    if (!_.isString(alertObj.type) || !_.isString(alertObj.message)) {
      console.warn('The alertObj', alertObj, 'is not a valid alert object, requires both type and message properties');
      return;
    }
    return $('#alert-messages').append("<div class='alert alert-" + alertObj.type + "' role='alert'>" + alertObj.message + "</div>");
  };

  window.loadLastActiveServer = function() {
    var activeServer;
    activeServer = Servers.getActiveServer();
    if (activeServer != null) {
      $('.privacy-list').css('display', 'none');
      $('.server-list').css('display', 'unset');
      $(document.body).addClass('loading');
      $('.loading-text').text(cordovai18n("Loading_s", activeServer.name));
      return Servers.startServer(activeServer.url, function(err, url) {
        navigator.splashscreen.hide();
        if (err != null) {
          return console.log(err);
        }
      });
    } else {
      return navigator.splashscreen.hide();
    }
  };

  document.addEventListener("deviceready", function() {
    var i, isIPad, item, key, language, len, query, queryString, ref, ref1, value;
    queryString = location.search.replace(/^\?/, '');
    query = {};
    if (queryString.length > 0) {
      ref = queryString.split('&');
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        ref1 = item.split('='), key = ref1[0], value = ref1[1];
        query[key] = value || true;
      }
    }
    isIPad = navigator.userAgent.indexOf("iPad") > 0;
    if (isIPad) {
      StatusBar.hide();
    }
    if (typeof Keyboard.hideKeyboardAccessoryBar === "function") {
      Keyboard.hideKeyboardAccessoryBar(false);
    }
    if (typeof Keyboard.disableScroll === "function") {
      Keyboard.disableScroll(false);
    }
    $('#serverAddressButton').on('click', function(e) {
      e.preventDefault();
      e.stopPropagation();
      Keyboard.hide();
      return setTimeout(function() {
        return registerServer();
      }, 100);
    });
    $('.server-list-info').on('click', function(e) {
      return toggleServerList();
    });
    $('#serverAddress').on('input', serverAddressInput);
    $(document).on('click', '#region-china-radio', function(e) {
      return $("#serverAddress").val(e.target.dataset.url);
    });
    $(document).on('click', '#region-us-radio', function(e) {
      return $("#serverAddress").val(e.target.dataset.url);
    });
    $(document).on('click', '#region-custom-radio', function(e) {
      return $("#serverAddress").val(e.target.dataset.url);
    });
    language = navigator.language.split('-').shift();
    if (language === "zh") {
      $('#region-china-radio').trigger('click');
    } else {
      $('#region-us-radio').trigger('click');
    }
    if (device.platform === "Android") {
      window.addEventListener("resize", function() {
        var a;
        a = document.getElementById('serverAddress');
        if (a) {
          return window.setTimeout(function() {
            return a.scrollIntoViewIfNeeded();
          }, 0);
        }
      });
    }
    return Servers.onLoad(function() {
      refreshServerList();
      if (query.updateServer != null) {
        navigator.splashscreen.hide();
        return updateServer(decodeURIComponent(query.updateServer), decodeURIComponent(query.version));
      }
      window.updateQuickActions();
      if (query.addServer == null) {
        return setTimeout(function() {
          if (window.AUTOLOAD === true) {
            return loadLastActiveServer();
          }
        }, 300);
      } else {
        return navigator.splashscreen.hide();
      }
    });
  });

}).call(this);
