// Generated by CoffeeScript 1.12.7
(function() {
  var addSwipeEventToOpenServerList, onAddServerClick, onServerClick, onServerDeleteClick;

  addSwipeEventToOpenServerList = function($el) {
    var started;
    started = void 0;
    $el.on('touchstart', function(e) {
      if (e.originalEvent.touches.length >= 2) {
        e.preventDefault();
        return started = {
          date: Date.now(),
          pageX: e.originalEvent.touches[0].pageX,
          pageY: e.originalEvent.touches[0].pageY
        };
      }
    });
    $el.on('touchmove', function(e) {
      if (started != null) {
        e.preventDefault();
        if (Date.now() - started.date < 2000) {
          if (Math.abs(e.originalEvent.touches[0].pageX - started.pageX) < 50) {
            if (Math.abs(e.originalEvent.touches[0].pageY - started.pageY) > 100) {
              toggleServerList();
              return started = void 0;
            }
          }
        }
      }
    });
    return $el.on('touchend', function(e) {
      return started = void 0;
    });
  };

  window.toggleServerList = function(open) {
    if (open === true) {
      return $(document.body).addClass('server-list-open');
    } else if (open === false) {
      return $(document.body).removeClass('server-list-open');
    } else {
      return $(document.body).toggleClass('server-list-open');
    }
  };

  window.refreshServerList = function() {
    return navigator.appInfo.getAppInfo(function(appInfo) {
      var i, len, li, overlay, ref, server, serverList, ul;
      serverList = document.querySelector("#serverList");
      if (serverList == null) {
        $(document.body).on('click', '#serverList .toggle', function() {
          return $('#serverList .panels').toggleClass('rotate');
        });
      }
      if (serverList != null) {
        serverList.remove();
      }
      overlay = document.querySelector(".server-list-overlay");
      if (overlay != null) {
        overlay.remove();
      }
      serverList = "<div id=\"serverList\">\n	<div class=\"panels\">\n		<div class=\"panel\">\n			<div class=\"toggle\">" + (cordovai18n('Server_List')) + "</div>\n			<ul>\n			</ul>\n		</div>\n		<div class=\"panel back\">\n			<div class=\"toggle\">" + (cordovai18n('Information')) + "</div>\n			<ul>\n				<li>Version: <span style=\"float: right;\">" + appInfo.version + "</span></li>\n				<li>Build: <span style=\"float: right;\">" + appInfo.build + "</span></li>\n			</ul>\n		</div>\n	</div>\n</div>";
      document.body.appendChild($('<div class="server-list-overlay"></div>')[0]);
      document.body.appendChild($(serverList)[0]);
      ul = document.querySelector("#serverList ul");
      ref = Servers.getServers();
      for (i = 0, len = ref.length; i < len; i++) {
        server = ref[i];
        li = "<li class=\"server\">\n	<div data-name=\"" + server.name + "\" data-url=\"" + server.url + "\" class=\"name\">" + server.name + "</div>\n	<div data-name=\"" + server.name + "\" data-url=\"" + server.url + "\" class=\"delete-btn\">\n		<svg aria-hidden=\"true\" role=\"img\" version=\"1.1\" viewBox=\"0 0 360 360\" style=\"width: 100%; height: 100%;\">\n			<path fill=\"#C31919\" d=\"M180.224,0C80.689,0,0,80.689,0,180.223c0,99.535,80.689,180.225,180.224,180.225 c99.536,0,180.225-80.689,180.225-180.225C360.449,80.689,279.759,0,180.224,0z M253.953,196.608H106.496V163.84h147.457V196.608z\"></path>\n		</svg>\n	</div>\n</li>";
        ul.appendChild($(li)[0]);
      }
      li = "<li class=\"addServer\">\n	<div class=\"name\"></div>\n	<div class=\"add-btn\">\n		<svg aria-hidden=\"true\" role=\"img\" version=\"1.1\" viewBox=\"0 0 360 360\" style=\"width: 100%; height: 100%;\">\n			<path fill=\"#19C319\" d=\"M180.224,0C80.689,0,0,80.689,0,180.223c0,99.535,80.689,180.225,180.224,180.225 c99.536,0,180.225-80.689,180.225-180.225C360.449,80.689,279.759,0,180.224,0z M253.953,196.608h-57.344v57.343h-32.768v-57.343 h-57.345V163.84h57.345v-57.344h32.768v57.344h57.344V196.608z\"></path>\n		</svg>\n	</div>\n</li>";
      return ul.appendChild($(li)[0]);
    });
  };

  onServerClick = function(e) {
    var target;
    toggleServerList(false);
    target = $(e.currentTarget);
    $(document.body).addClass('loading');
    $('.loading-text').text(cordovai18n("Loading_s", target.data('name')));
    return setTimeout(function() {
      Servers.setActiveServer(target.data('url'));
      return Servers.startServer(target.data('url'), function() {});
    }, 200);
  };

  onServerDeleteClick = function(e) {
    var onConfirm, target;
    target = $(e.currentTarget);
    onConfirm = function(buttonIndex) {
      var activeServer;
      if (buttonIndex !== 1) {
        return;
      }
      activeServer = Servers.getActiveServer();
      return Servers.deleteServer(target.data('url'), function() {
        if (activeServer.url === target.data('url')) {
          return onAddServerClick();
        } else {
          return refreshServerList();
        }
      });
    };
    return navigator.notification.confirm(cordovai18n("Delete_server_s_question", target.data('name')), onConfirm, cordovai18n("Warning"), [cordovai18n("Delete"), cordovai18n("Cancel")]);
  };

  onAddServerClick = function() {
    return Servers.startLocalServer("index.html?addServer");
  };

  window.addEventListener("onNewVersion", function(e) {
    return Servers.onLoad((function(_this) {
      return function() {
        var onConfirm, server, url, version;
        url = Meteor.absoluteUrl().replace(/\/$/, '');
        version = e.detail;
        server = Servers.getServer(url);
        if (server == null) {
          navigator.notification.alert(cordovai18n("The_URL_configured_in_your_server_s_is_not_the_same_that_you_are_using_here", url), null, cordovai18n("Warning"));
          return;
        }
        if (server.info.version === version) {
          return;
        }
        onConfirm = function(buttonIndex) {
          if (buttonIndex === 1) {
            Servers.startLocalServer(window.urlToUpdate);
          }
          return window.urlToUpdate = void 0;
        };
        if (window.urlToUpdate == null) {
          navigator.notification.confirm(cordovai18n("There_is_a_new_version_available_do_you_want_to_update_now_question"), onConfirm, cordovai18n("New_version"), [cordovai18n("Update"), cordovai18n("Cancel")]);
        }
        return window.urlToUpdate = "index.html?updateServer=" + (encodeURIComponent(url)) + "&version=" + (encodeURIComponent(version));
      };
    })(this));
  });

  document.addEventListener("deviceready", function() {
    Servers.onLoad(function() {
      return refreshServerList();
    });
    $(document).on('click', '#serverList .server .name', onServerClick);
    $(document).on('click', '#serverList .server .delete-btn', onServerDeleteClick);
    $(document).on('click', '#serverList .addServer', onAddServerClick);
    $(document).on('click', "#serverList:not(.toggle)", function(e) {
      if ($(e.target).is('#serverList')) {
        return toggleServerList(false);
      }
    });
    document.addEventListener('click', function(e) {
      if (e.target.nodeName === 'A' && e.target.getAttribute('href') === '#') {
        e.stopPropagation();
        return e.preventDefault();
      }
    });
    addSwipeEventToOpenServerList($(document));
    return ThreeDeeTouch.onHomeIconPressed = function(payload) {
      navigator.splashscreen.show();
      return Servers.onLoad(function() {
        var activeServer, host;
        if (payload.type === 'new') {
          window.AUTOLOAD = false;
          navigator.splashscreen.hide();
          return Servers.startLocalServer("index.html?addServer");
        }
        host = payload.type.replace(/\/$/, '');
        if (Servers.serverExists(host) !== true) {
          navigator.splashscreen.hide();
          return;
        }
        activeServer = Servers.getActiveServer();
        if ((activeServer != null) && activeServer.url === host && (window.Meteor != null)) {
          navigator.splashscreen.hide();
          return;
        }
        window.AUTOLOAD = false;
        navigator.splashscreen.hide();
        return Servers.startServer(host, function(err, url) {
          if (err != null) {
            return console.log(err);
          }
        });
      });
    };
  });

}).call(this);
